import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.util.HashSet;

import de.uni_mannheim.informatik.dws.dwslib.util.DomainUtil;
import de.uni_mannheim.informatik.dws.dwslib.util.InputUtil;


public class DSStats {
	
	public static void main(String[] args) throws IOException {
		BufferedReader br = InputUtil.getBufferedReader(new File(args[0]));
		HashSet<String> hosts = new HashSet<String>();
		int lnCnt = 0;
		while (br.ready()){
			if (++lnCnt % 200000 == 0){
				System.out.println("Parsed " + lnCnt + " lines.");
			}
			String line = br.readLine();
			String tok[] = line.split("\t");
			String url = tok[1];
			if (url != null){
				String host = DomainUtil.getSubDomainFromWholeUrl(url);
				if (host != null){
					hosts.add(host);
				}
			}
		}
		System.out.println("Found " + hosts.size() + " hosts");
	}

}
