package com.yahoo.research.robme.anthelion.framework;

import java.util.Date;

import com.yahoo.research.robme.anthelion.models.AnthHost;
import com.yahoo.research.robme.anthelion.models.AnthURL;

public class UrlPusher implements Runnable {

	private AnthProcessor p;
	private boolean run;
	// those are only statistical counts - they should not be used to caluclate
	// some score for decisions for the process
	protected long pushedUrl;
	protected long processingTime;
	protected long good;
	protected long bad;
	protected long predictedRight;
	private boolean classifyOnPush;

	public UrlPusher(AnthProcessor p, boolean classifyOnPush) {
		this.p = p;
		this.classifyOnPush = classifyOnPush;

	}

	public void switchOf() {
		run = false;
	}

	@Override
	public void run() {
		run = true;
		while (run) {
			if (p.queuedDomains.peek() != null) {
				long timeStart = new Date().getTime();
				AnthHost nextHost = p.queuedDomains.poll();
				if (classifyOnPush) {
					nextHost.classify(p.onlineLearner);
				}
				AnthURL aurl = nextHost.getNextUrlToCrawl();
				if (aurl != null) {
					if (aurl.sem) {
						good++;
						if (aurl.prediction >= 0) {
							predictedRight++;
						}
					} else {
						bad++;
						if (aurl.prediction <= 0) {
							predictedRight++;
						}
					}
					p.outputList.add(aurl);
					nextHost.dequeue();
					pushedUrl++;
					processingTime += new Date().getTime() - timeStart;
				}
			} else {
				try {
					// System.out.println("URL Pusher says: Nothing to push after pushing "
					// + pushedUrl + " ... waiting.");
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					// TODO some nice log
					e.printStackTrace();
				}
			}
		}
	}

}
