package com.yahoo.research.robme.anthelion.mao;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import moa.classifiers.Classifier;
import moa.classifiers.bayes.NaiveBayes;
import moa.core.Measurement;
import moa.streams.ArffFileStream;
import weka.core.Instance;

public class MaoTest {
	
	public static void main(String[] args) {

        Classifier learner = new NaiveBayes();
        ArffFileStream stream = new ArffFileStream(args[0],
                        Integer.parseInt(args[1]));

        
        learner.setModelContext(stream.getHeader());
        learner.prepareForUse();
        List<Instance> arffItems = new ArrayList<Instance>();
        while (stream.hasMoreInstances()) {
        	arffItems.add(stream.nextInstance());
        }
        //shake it baby!
        Collections.shuffle(arffItems);
       
        int sampleNum = 0;
        int correctClassified = 0;
        double accuracy = 0.0;
        for (Instance instance : arffItems) {
                if (learner.correctlyClassifies(instance)) {
                        correctClassified++;
                }
//                double prediction[] = learner.getVotesForInstance(instance);
//                for (int i = 0; i < prediction.length; i++){
//                	System.out.println("Prediction for class " + i + " is: " + prediction[i]);
//                }
                learner.trainOnInstance(instance);
                
                
                sampleNum++;
                if (sampleNum % 10 == 0){
                        accuracy = 100.0 * (double) correctClassified
                                        / (double) sampleNum;
                        System.out.println("Accuracy after " + sampleNum + " examples is " + accuracy);
                }
        }
        Measurement[] m = learner.getModelMeasurements();
        for (int i = 0; i < m.length ; i++){
        	System.out.println(m[i].getName() + " = " + m[i].getValue());
        }
        
        accuracy = 100.0 * (double) correctClassified
                        / (double) sampleNum;
        System.out.println("Final accuracy after " + sampleNum + " examples is " + accuracy);
}


}
