package com.yahoo.research.robme.anthelion.models.banditfunction;

import java.util.Properties;

import com.yahoo.research.robme.anthelion.models.AnthHost;
import com.yahoo.research.robme.anthelion.models.HostValueUpdateNecessity;

/**
 * Calculates the score of a domain as the ratio between good and bad URLs.
 * 
 * @author Robert Meusel
 * 
 */
public class DomainSuccessRateFunction implements DomainValueFunction {

	private int alpha = 1;
	private int beta = 1;

	@Override
	public double getDomainValue(AnthHost domain) {
		return ((double) domain.goodUrls + alpha)
				/ ((double) domain.badUrls + beta);
	}

	@Override
	public void setProperty(Properties prop) {
		// not necessary for this function
	}

	@Override
	public boolean getNecessities(HostValueUpdateNecessity nec) {
		if (nec == HostValueUpdateNecessity.ON_STAT_CHANGE){
			return true;
		}
		if (nec == HostValueUpdateNecessity.ON_QUEUE_CHANGE){
			return false;
		}
		return false;
	}

}
