package com.yahoo.research.robme.anthelion.simulation;

import java.util.Queue;

import com.yahoo.research.robme.anthelion.framework.AnthProcessor;
import com.yahoo.research.robme.anthelion.models.AnthURL;

public class FeedbackPusher implements Runnable {
	public AnthProcessor p;
	public Queue<AnthURL> readyUrls;
	protected boolean run;

	public FeedbackPusher(AnthProcessor p, Queue<AnthURL> readyUrls) {
		super();
		this.p = p;
		this.readyUrls = readyUrls;
	}

	public void switchOf() {
		run = false;
	}

	@Override
	public void run() {
		run = true;
		while (run) {
			AnthURL url = readyUrls.poll();
			if (url != null) {
				p.addFeedback(url.uri, url.sem);
				
				// TODO here some limitations are missing like: Delay based on
				// download, chunking based on discovery from URL
				
				
			} else {
				try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}

	}
}