/*
 *    AutoExpandVector.java
 *    Copyright (C) 2007 University of Waikato, Hamilton, New Zealand
 *    @author Richard Kirkby (rkirkby@cs.waikato.ac.nz)
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program. If not, see <http://www.gnu.org/licenses/>.
 *    
 */
package moa.core;

import java.util.HashMap;

import moa.AbstractMOAObject;
import moa.MOAObject;

/**
 * Vector with the capability of automatic expansion.
 * 
 * @author Richard Kirkby (rkirkby@cs.waikato.ac.nz)
 * @version $Revision: 7 $
 */
public class AutoExpandMapVector<T> extends HashMap<Integer, T> implements
		MOAObject {

	private static final long serialVersionUID = 1L;

	public AutoExpandMapVector() {
		super(0);
	}

	@Override
	public MOAObject copy() {
		return AbstractMOAObject.copy(this);
	}

	@Override
	public int measureByteSize() {
		return AbstractMOAObject.measureByteSize(this);
	}

	@Override
	public void getDescription(StringBuilder sb, int indent) {
		// TODO Auto-generated method stub
	}
}